数组中重复的数字

1.题目:
在一个长度为n的数组里的所有数字都在0到n-1的范围内。 数组中某些数字是重复的,但不知道有几个数字是重复的。也不知道每个数字重复几次。请找出数组中任意一个重复的数字。 例如,如果输入长度为7的数组{2,3,1,0,2,5,3},那么对应的输出是第一个重复的数字2。
2.思路:
方法一:哈希+遍历
利用HashMap存储每个数,在遍历存储的过程中,遇到重复的马上返回true
时间复杂度:O(n)
空间复杂度:O(n)

import java.util.HashMap;
public class Solution {
    // Parameters:
    //    numbers:     an array of integers
    //    length:      the length of array numbers
    //    duplication: (Output) the duplicated number in the array number,length of duplication array is 1,so    using duplication[0] = ? in implementation;
    //                  Here duplication like pointor in C/C++, duplication[0] equal *duplication in C/C++
    //    这里要特别注意~返回任意重复的一个,赋值duplication[0]
    // Return value:       true if the input is valid, and there are some duplications in the array number
    //                     otherwise false
    public boolean duplicate(int numbers[],int length,int [] duplication) {
        HashMap<Integer,Integer>hashMap=new HashMap<>();
        for(int i=0;i<length;i++){
            if(hashMap.containsValue(numbers[i])){
                duplication[0]=numbers[i];
                return true;
            }else{
                hashMap.put(i,numbers[i]);
            }
        }
        return false;
    }
}

方法二:排序法
将输入数组排序,再判断相邻位置是否存在相同数字,如果存在,对 duplication 赋值返回,否则继续比较
时间复杂度:O(NlogN)
空间复杂度:O(1)

import java.util.Arrays;
public class Solution {
    // Parameters:
    //    numbers:     an array of integers
    //    length:      the length of array numbers
    //    duplication: (Output) the duplicated number in the array number,length of duplication array is 1,so using duplication[0] = ? in implementation;
    //                  Here duplication like pointor in C/C++, duplication[0] equal *duplication in C/C++
    //    这里要特别注意~返回任意重复的一个,赋值duplication[0]
    // Return value:       true if the input is valid, and there are some duplications in the array number
    //                     otherwise false
    public boolean duplicate(int numbers[],int length,int [] duplication) {
        if(numbers==null||length==0){
            return false;
        }
        Arrays.sort(numbers);
        for(int i=0;i<length-1;i++){//注意此处为length-1,因为存在arr[i+1]可能会造成溢出
            if(numbers[i]==numbers[i+1]){
                duplication[0]=numbers[i];
                return true;
            }
        }
        return false;
    }
}

方法三;in-place算法

  1. 分析
    数组的长度为 n 且所有数字都在 0 到 n-1 的范围内,我们可以将每次遇到的数进行"归位",当某个数发现自己的"位置"被相同的数占了,则出现重复。
    扫描整个数组,当扫描到下标为 i 的数字时,首先比较该数字(m)是否等于 i,如果是,则接着扫描下一个数字;如果不是,则拿 m 与第 m 个数比较。如果 m 与第 m 个数相等,则说明出现重复了;如果 m 与第 m 个数不相等,则将 m 与第 m 个数交换,将 m "归位",再重复比较交换的过程,直到发现重复的数

举个栗子:
以数组 {2,3,1,0,2,5,3} 为例

  • 当 i = 0 时,nums[i] = 2 != i,判断 nums[i] 不等于 nums[nums[i]],交换 nums[i] 和 nums[nums[i]],交换后数组为:{1,3,2,0,2,5,3}
  • 此时 i = 0,nums[i] = 1 != i,判断 nums[i] 不等于 nums[nums[i]],交换 nums[i] 和 nums[nums[i]],交换后数组为:{3,1,2,0,2,5,3}
  • 此时 i = 0,nums[i] = 3 != i,判断 nums[i] 不等于 nums[nums[i]],交换 nums[i] 和 nums[nums[i]],交换后数组为:{0,1,2,3,2,5,3}
  • 此时 i = 0,nums[i] = 0 = i,继续下一组
  • 当 i = 1,nums[i] = 1 = i,继续下一组
  • 当 i = 2,nums[i] = 2 = i,继续下一组
  • 当 i = 3,nums[i] = 3 = i,继续下一组
  • 当 i = 4,nums[i] = 2 != i,判断 nums[i] 等于 nums[nums[i]],出现重复,赋值返回
    时间复杂度:O(n)
    空间复杂度:O(1)
    public class Solution {
      // Parameters:
      //    numbers:     an array of integers
      //    length:      the length of array numbers
      //    duplication: (Output) the duplicated number in the array number,length of duplication array is 1,so using duplication[0] = ? in implementation;
      //                  Here duplication like pointor in C/C++, duplication[0] equal *duplication in C/C++
      //    这里要特别注意~返回任意重复的一个,赋值duplication[0]
      // Return value:       true if the input is valid, and there are some duplications in the array number
      //                     otherwise false
      public boolean duplicate(int numbers[],int length,int [] duplication) {
          if(numbers==null||length==0){
              return false;
          }
              for(int i=0;i<length;i++){
                  if(numbers[i]!=i){//当前数与下标不等
                      if(numbers[i]==numbers[numbers[i]]){//出现重复
                          duplication[0]=numbers[i];
                          return true;
                      }else{//不等,则交换
                          int temp=numbers[i];
                          numbers[i]=numbers[numbers[i]];
                          numbers[temp]=temp;
                      }
                  }
              }//如果当前数与下表相等,则i++
          return false;
      }
    }
全部评论

相关推荐

点赞 收藏 评论
分享
牛客网
牛客企业服务